Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerresource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerresource.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerresource.php	(revision )
@@ -0,0 +1,44 @@
+<?php
+
+/**
+ * Smarty Method RegisterResource
+ *
+ * Smarty::registerResource() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterResource
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers a resource to fetch a template
+     *
+     * @api  Smarty::registerResource()
+     * @link http://www.smarty.net/docs/en/api.register.resource.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $name             name of resource type
+     * @param  Smarty_Resource|array                                          $resource_handler or instance of
+     *                                                                                          Smarty_Resource, or
+     *                                                                                          array of callbacks to
+     *                                                                                          handle resource
+     *                                                                                          (deprecated)
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function registerResource(Smarty_Internal_TemplateBase $obj, $name, $resource_handler)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        $smarty->registered_resources[$name] = $resource_handler instanceof
+        Smarty_Resource ? $resource_handler : array($resource_handler, false);
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/debug.tpl
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/debug.tpl	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/debug.tpl	(revision )
@@ -5,7 +5,7 @@
         <title>Smarty Debug Console</title>
         <style type="text/css">
             {literal}
-            body, h1, h2, td, th, p {
+            body, h1, h2, h3, td, th, p {
                 font-family: sans-serif;
                 font-weight: normal;
                 font-size: 0.9em;
@@ -31,6 +31,13 @@
                 padding: 2px;
                 border-top: 1px solid black;
             }
+            h3 {
+                text-align: left;
+                font-weight: bold;
+                color: black;
+                font-size: 0.7em;
+                padding: 2px;
+            }
 
             body {
                 background: black;
@@ -54,7 +61,6 @@
                 font-family: monospace;
                 vertical-align: top;
                 text-align: left;
-                width: 50%;
             }
 
             td {
@@ -74,8 +80,20 @@
                 font-style: italic;
             }
 
+            #bold div {
+                color: black;
+                font-weight: bold;
+            }
+            #blue h3 {
+                color: blue;
+            }
+            #normal div {
+                color: black;
+                font-weight: normal;
+            }
             #table_assigned_vars th {
                 color: blue;
+                font-weight: bold;
             }
 
             #table_config_vars th {
@@ -87,18 +105,17 @@
     </head>
     <body>
 
-    <h1>Smarty Debug Console
-        -  {if isset($template_name)}{$template_name|debug_print_var nofilter}{else}Total Time {$execution_time|string_format:"%.5f"}{/if}</h1>
+    <h1>Smarty {Smarty::SMARTY_VERSION} Debug Console
+        -  {if isset($template_name)}{$template_name|debug_print_var nofilter} {/if}{if !empty($template_data)}Total Time {$execution_time|string_format:"%.5f"}{/if}</h1>
 
     {if !empty($template_data)}
         <h2>included templates &amp; config files (load time in seconds)</h2>
         <div>
             {foreach $template_data as $template}
                 <font color=brown>{$template.name}</font>
-                <span class="exectime">
-   (compile {$template['compile_time']|string_format:"%.5f"}) (render {$template['render_time']|string_format:"%.5f"}) (cache {$template['cache_time']|string_format:"%.5f"}
-                    )
+                <br>&nbsp;&nbsp;<span class="exectime">
+                (compile {$template['compile_time']|string_format:"%.5f"}) (render {$template['render_time']|string_format:"%.5f"}) (cache {$template['cache_time']|string_format:"%.5f"})
-  </span>
+                 </span>
                 <br>
             {/foreach}
         </div>
@@ -109,19 +126,24 @@
     <table id="table_assigned_vars">
         {foreach $assigned_vars as $vars}
             <tr class="{if $vars@iteration % 2 eq 0}odd{else}even{/if}">
-                <th>${$vars@key|escape:'html'}</th>
-                <td>{$vars|debug_print_var nofilter}</td>
-            </tr>
+                <td><h3><font color=blue>${$vars@key}</font></h3>
+                    {if isset($vars['nocache'])}<b>Nocache</b></br>{/if}
+                    {if isset($vars['scope'])}<b>Origin:</b> {$vars['scope']|debug_print_var nofilter}{/if}
+                </td>
+                <td><h3>Value</h3>{$vars['value']|debug_print_var:10:80 nofilter}</td>
+                <td>{if isset($vars['attributes'])}<h3>Attributes</h3>{$vars['attributes']|debug_print_var nofilter} {/if}</td>
-        {/foreach}
+         {/foreach}
     </table>
 
-    <h2>assigned config file variables (outer template scope)</h2>
+    <h2>assigned config file variables</h2>
 
     <table id="table_config_vars">
         {foreach $config_vars as $vars}
             <tr class="{if $vars@iteration % 2 eq 0}odd{else}even{/if}">
-                <th>{$vars@key|escape:'html'}</th>
-                <td>{$vars|debug_print_var nofilter}</td>
+                <td><h3><font color=blue>#{$vars@key}#</font></h3>
+                    {if isset($vars['scope'])}<b>Origin:</b> {$vars['scope']|debug_print_var nofilter}{/if}
+                </td>
+                <td>{$vars['value']|debug_print_var:10:80 nofilter}</td>
             </tr>
         {/foreach}
 
@@ -130,8 +152,9 @@
     </html>
 {/capture}
 <script type="text/javascript">
-    {$id = $template_name|default:''|md5}
-    _smarty_console = window.open("", "console{$id}", "width=680,height=600,resizable,scrollbars=yes");
+    {$id = '__Smarty__'}
+    {if $display_mode}{$id = "$offset$template_name"|md5}{/if}
+    _smarty_console = window.open("", "console{$id}", "width=1024,height=600,left={$offset},top={$offset},resizable,scrollbars=yes");
     _smarty_console.document.write("{$debug_output|escape:'javascript' nofilter}");
     _smarty_console.document.close();
-</script>
\ No newline at end of file
+</script>
Index: src/includes/classes/Smarty/plugins/shared.mb_str_replace.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/shared.mb_str_replace.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/shared.mb_str_replace.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/plugins/modifier.debug_print_var.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifier.debug_print_var.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifier.debug_print_var.php	(revision )
@@ -14,26 +14,30 @@
  *
  * @author Monte Ohrt <monte at ohrt dot com>
  *
- * @param array|object $var    variable to be formatted
+ * @param array|object $var     variable to be formatted
- * @param integer      $depth  maximum recursion depth if $var is an array
- * @param integer      $length maximum string length if $var is a string
+ * @param int          $max     maximum recursion depth if $var is an array or object
+ * @param int          $length  maximum string length if $var is a string
+ * @param int          $depth   actual recursion depth
+ * @param array        $objects processed objects in actual depth to prevent recursive object processing
  *
  * @return string
  */
-function smarty_modifier_debug_print_var($var, $depth = 0, $length = 40)
+function smarty_modifier_debug_print_var($var, $max = 10, $length = 40, $depth = 0, $objects = array())
 {
-    $_replace = array("\n" => '<i>\n</i>',
-                      "\r" => '<i>\r</i>',
-                      "\t" => '<i>\t</i>'
+    $_replace = array("\n" => '\n',
+                      "\r" => '\r',
+                      "\t" => '\t'
     );
-
     switch (gettype($var)) {
         case 'array' :
             $results = '<b>Array (' . count($var) . ')</b>';
+            if ($depth == $max) {
+                break;
+            }
             foreach ($var as $curr_key => $curr_val) {
                 $results .= '<br>' . str_repeat('&nbsp;', $depth * 2)
                     . '<b>' . strtr($curr_key, $_replace) . '</b> =&gt; '
-                    . smarty_modifier_debug_print_var($curr_val, ++$depth, $length);
+                    . smarty_modifier_debug_print_var($curr_val, $max, $length, ++ $depth, $objects);
                 $depth --;
             }
             break;
@@ -41,10 +45,18 @@
         case 'object' :
             $object_vars = get_object_vars($var);
             $results = '<b>' . get_class($var) . ' Object (' . count($object_vars) . ')</b>';
+            if (in_array($var, $objects)) {
+                $results .= ' called recursive';
+                break;
+            }
+            if ($depth == $max) {
+                break;
+            }
+            $objects[] = $var;
             foreach ($object_vars as $curr_key => $curr_val) {
                 $results .= '<br>' . str_repeat('&nbsp;', $depth * 2)
                     . '<b> -&gt;' . strtr($curr_key, $_replace) . '</b> = '
-                    . smarty_modifier_debug_print_var($curr_val, ++$depth, $length);
+                    . smarty_modifier_debug_print_var($curr_val, $max, $length, ++ $depth, $objects);
                 $depth --;
             }
             break;
Index: src/includes/classes/Smarty/plugins/modifiercompiler.wordwrap.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.wordwrap.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.wordwrap.php	(revision )
@@ -34,11 +34,11 @@
     $function = 'wordwrap';
     if (Smarty::$_MBSTRING) {
         if ($compiler->template->caching && ($compiler->tag_nocache | $compiler->nocache)) {
-            $compiler->template->required_plugins['nocache']['wordwrap']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'shared.mb_wordwrap.php';
+            $compiler->parent_compiler->template->compiled->required_plugins['nocache']['wordwrap']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'shared.mb_wordwrap.php';
             $compiler->template->required_plugins['nocache']['wordwrap']['modifier']['function'] = 'smarty_mb_wordwrap';
         } else {
-            $compiler->template->required_plugins['compiled']['wordwrap']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'shared.mb_wordwrap.php';
-            $compiler->template->required_plugins['compiled']['wordwrap']['modifier']['function'] = 'smarty_mb_wordwrap';
+            $compiler->parent_compiler->template->compiled->required_plugins['compiled']['wordwrap']['modifier']['file'] = SMARTY_PLUGINS_DIR . 'shared.mb_wordwrap.php';
+            $compiler->parent_compiler->template->compiled->required_plugins['compiled']['wordwrap']['modifier']['function'] = 'smarty_mb_wordwrap';
         }
         $function = 'smarty_mb_wordwrap';
     }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_createdata.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_createdata.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_createdata.php	(revision )
@@ -0,0 +1,44 @@
+<?php
+
+/**
+ * Smarty Method CreateData
+ *
+ * Smarty::createData() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_CreateData
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * creates a data object
+     *
+     * @api  Smarty::createData()
+     * @link http://www.smarty.net/docs/en/api.create.data.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty      $obj
+     * @param \Smarty_Internal_Template|\Smarty_Internal_Data|\Smarty_Data|\Smarty $parent next higher level of Smarty
+     *                                                                                     variables
+     * @param string                                                               $name   optional data block name
+     *
+     * @returns Smarty_Data data object
+     */
+    public function createData(Smarty_Internal_TemplateBase $obj, Smarty_Internal_Data $parent = null, $name = null)
+    {
+        /* @var Smarty $smarty */
+        $smarty = isset($this->smarty) ? $this->smarty : $obj;
+        $dataObj = new Smarty_Data($parent, $smarty, $name);
+        if ($smarty->debugging) {
+            Smarty_Internal_Debug::register_data($dataObj);
+        }
+        return $dataObj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterobject.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterobject.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_unregisterobject.php	(revision )
@@ -0,0 +1,40 @@
+<?php
+
+/**
+ * Smarty Method UnregisterObject
+ *
+ * Smarty::unregisterObject() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_UnregisterObject
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers plugin to be used in templates
+     *
+     * @api  Smarty::unregisterObject()
+     * @link http://www.smarty.net/docs/en/api.unregister.object.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $object_name name of object
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function unregisterObject(Smarty_Internal_TemplateBase $obj, $object_name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (isset($smarty->registered_objects[$object_name])) {
+            unset($smarty->registered_objects[$object_name]);
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/modifiercompiler.upper.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.upper.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.upper.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_addautoloadfilters.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_addautoloadfilters.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_addautoloadfilters.php	(revision )
@@ -0,0 +1,51 @@
+<?php
+
+/**
+ * Smarty Method AddAutoloadFilters
+ *
+ * Smarty::addAutoloadFilters() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_AddAutoloadFilters extends Smarty_Internal_Method_SetAutoloadFilters
+{
+
+    /**
+     * Add autoload filters
+     *
+     * @api Smarty::setAutoloadFilters()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  array                                                          $filters filters to load automatically
+     * @param  string                                                         $type    "pre", "output", … specify the
+     *                                                                                 filter type to set. Defaults to
+     *                                                                                 none treating $filters' keys as
+     *                                                                                 the appropriate types
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function addAutoloadFilters(Smarty_Internal_TemplateBase $obj, $filters, $type = null)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if ($type !== null) {
+            $this->_checkFilterType($type);
+            if (!empty($smarty->autoload_filters[$type])) {
+                $smarty->autoload_filters[$type] = array_merge($smarty->autoload_filters[$type], (array) $filters);
+            } else {
+                $smarty->autoload_filters[$type] = (array) $filters;
+            }
+        } else {
+            foreach ((array) $filters as $type => $value) {
+                $this->_checkFilterType($type);
+                if (!empty($smarty->autoload_filters[$type])) {
+                    $smarty->autoload_filters[$type] = array_merge($smarty->autoload_filters[$type], (array) $value);
+                } else {
+                    $smarty->autoload_filters[$type] = (array) $value;
+                }
+            }
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
